import os.path
from twisted.words.protocols.jabber.jid import parse
from twisted.python.filepath import FilePath

class GadgetRoster(object):
    def __init__(self, path):
        # FIXME: maybe we could use SQLite?
        self._path = path
        self._jids = set()

        if os.path.isfile(path):
            self._load(path)

    def _load(self, path):
        for line in file(path, 'r'):
            user, host, resource = parse(line.strip())

            if user is None or host is None or resource is not None:
                continue

            self._jids.add(line.strip())

    def _save(self):
        FilePath(self._path, 'w').setContent(''.join('%s\n' %
            x for x in self._jids))

    def add(self, jid):
        self._jids.add(jid)
        self._save()

    def remove(self, jid):
        try:
            self._jids.remove(jid)
        except KeyError:
            pass
        else:
            self._save()

    def __len__(self):
        return len(self._jids)

    def __iter__(self):
        return iter(self._jids)

    def __contains__(self, item):
        return item in self._jids
